/*
 * Original code based on Host AP (software wireless LAN access point) driver 
 * for Intersil Prism2/2.5/3.
 *
 * Copyright (c) 2001-2002, SSH Communications Security Corp and Jouni Malinen
 * <jkmaline@cc.hut.fi>
 * Copyright (c) 2002-2003, Jouni Malinen <jkmaline@cc.hut.fi>
 *
 * Adaption to a generic IEEE 802.11 stack by James Ketrenos 
 * <jketreno@linux.intel.com>
 *
 * Copyright (c) 2004, Intel Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

/*
 * This file defines the interface to the ieee80211 crypto module.  
 */
#ifndef IEEE80211_CRYPT_H
#define IEEE80211_CRYPT_H

#include "../hostap_crypt.h"

struct ieee80211_crypt_data {
	struct list_head list; /* delayed deletion list */
	struct hostap_crypto_ops *ops;
	void *priv;
	atomic_t refcnt;
};

#endif
