/* $Id: linux_logo.h,v 1.8 1998/07/30 16:30:24 jj Exp $
 * include/asm-i386/linux_logo.h: This is a linux logo
 *                                to be displayed on boot.
 *
 * Copyright (C) 1996 Larry Ewing (lewing@isc.tamu.edu)
 * Copyright (C) 1996 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
 *
 * You can put anything here, but:
 * LINUX_LOGO_COLORS has to be less than 224
 * image size has to be 80x80
 * values have to start from 0x20
 * (i.e. RGB(linux_logo_red[0],
 *	     linux_logo_green[0],
 *	     linux_logo_blue[0]) is color 0x20)
 * BW image has to be 80x80 as well, with MS bit
 * on the left
 * Serial_console ascii image can be any size,
 * but should contain %s to display the version
 */
 
#include <linux/init.h>
#include <linux/version.h>

#define linux_logo_banner "Linux/ia32 version " UTS_RELEASE

#ifndef CONFIG_FRAME_BUFFER_BOOT_LOGOS
 #ifndef CONFIG_FRAME_BUFFER_BOOT_NOLOGO
   #include <linux/linux_logo/linux_logo-wolk1.h>
 #else
   #include <linux/linux_logo/linux_logo-nologo.h>
 #endif
#endif

#ifdef CONFIG_FB_LOGO_TUX
#include <linux/linux_logo.h>
#endif

#ifdef CONFIG_FB_LOGO_TUX_BEACH
#include <linux/linux_logo/linux_logo-tux-beach.h>
#endif

#ifdef CONFIG_FB_LOGO_TUX_DOOM
#include <linux/linux_logo/linux_logo-tux-doom.h>
#endif

#ifdef CONFIG_FB_LOGO_WOLK1
#include <linux/linux_logo/linux_logo-wolk1.h>
#endif

#ifdef CONFIG_FB_LOGO_KONDARA_MNU_LINUX
#include <linux/linux_logo/linux_logo-kondara-mnu.h>
#endif

#ifdef CONFIG_FB_LOGO_BABY_GNU
#include <linux/linux_logo/linux_logo-baby-gnu.h>
#endif

#ifdef CONFIG_FB_LOGO_LINUX_INSIDE
#include <linux/linux_logo/linux_logo-linux-inside.h>
#endif

#ifdef CONFIG_FB_LOGO_LINUX_NEWAGE
#include <linux/linux_logo/linux_logo-linux-newage.h>
#endif

#ifdef CONFIG_FB_LOGO_DEBIAN1
#include <linux/linux_logo/linux_logo-debian1.h>
#endif

#ifdef CONFIG_FB_LOGO_DEBIAN2
#include <linux/linux_logo/linux_logo-debian2.h>
#endif

#ifdef CONFIG_FB_LOGO_REDHAT1
#include <linux/linux_logo/linux_logo-redhat1.h>
#endif

#ifdef CONFIG_FB_LOGO_MANDRAKE1
#include <linux/linux_logo/linux_logo-mandrake1.h>
#endif

#ifdef CONFIG_FB_LOGO_SLACKWARE1
#include <linux/linux_logo/linux_logo-slackware1.h>
#endif

#ifdef CONFIG_FB_LOGO_SLACKWARE2
#include <linux/linux_logo/linux_logo-slackware2.h>
#endif

#ifdef CONFIG_FB_LOGO_GENTOO_LARRY
#include <linux/linux_logo/linux_logo-larry_cow_gentoo.h>
#endif

#ifdef CONFIG_FB_LOGO_GENTOO
#include <linux/linux_logo/linux_logo-gentoo.h>
#endif

#ifdef CONFIG_FB_LOGO_GENTOO_POWEREDBY
#include <linux/linux_logo/linux_logo-poweredbygentoo.h>
#endif

#ifdef CONFIG_FB_LOGO_FREEBSD
#include <linux/linux_logo/freebsd.png.h>
#endif

#ifdef CONFIG_FB_LOGO_GNU_ALT
#include <linux/linux_logo/gnu-alternative.png.h>
#endif

#ifdef CONFIG_FB_LOGO_GSAM
#include <linux/linux_logo/gsam_want_gnu_medium.jpg.h>
#endif

#ifdef CONFIG_FB_LOGO_HURD
#include <linux/linux_logo/hurd_sm_mf.png.h>
#endif

#ifdef CONFIG_FB_LOGO_MOL_BIG
#include <linux/linux_logo/mol_b_big.png.h>
#endif

#ifdef CONFIG_FB_LOGO_MOL_MEDIUM
#include <linux/linux_logo/mol_b_medium.png.h>
#endif

#ifdef CONFIG_FB_LOGO_OPENBSD_CHIX
#include <linux/linux_logo/openbsd-chix-dig-openbsd-smaller.png.h>
#endif

#ifdef CONFIG_FB_LOGO_OPENBSD_PUFFY
#include <linux/linux_logo/openbsd-puffy.png.h>
#endif

#ifdef CONFIG_FB_LOGO_OPENBSD_SBD
#include <linux/linux_logo/openbsd-sbd.png.h>
#endif

#ifdef CONFIG_FB_LOGO_OPENBSD_WF_TINY
#include <linux/linux_logo/openbsd-wireframe-tiny.png.h>
#endif

#ifdef CONFIG_FB_LOGO_OPENBSD_WF
#include <linux/linux_logo/openbsd-wireframe1.png.h>
#endif

#ifdef CONFIG_FB_LOGO_PLD
#include <linux/linux_logo/pld_logo.png.h>
#endif

#ifdef CONFIG_FB_LOGO_PLD_HORIZONTAL
#include <linux/linux_logo/pld_logo_horizontal.png.h>
#endif

#ifdef CONFIG_FB_LOGO_PLD_MINI
#include <linux/linux_logo/pld_mini_logo.png.h>
#endif

#ifdef CONFIG_FB_LOGO_PLD_PINK
#include <linux/linux_logo/pld_pink_logo.png.h>
#endif

